#
# spec file for package nagios (Version 2.6)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl apache2 apache2-devel apache2-prefork attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison brp-check-internal bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs ed expat file filesystem fillup findutils flex fontconfig fontconfig-devel freetype2 freetype2-devel gawk gcc gd gd-devel gdbm gdbm-devel gettext gettext-devel glibc glibc-32bit glibc-devel glibc-locale gpm grep groff gzip info insserv iputils klogd krb5 less libacl libapr-util1 libapr-util1-devel libapr1 libapr1-devel libattr libcom_err libgcc libgssapi libjpeg libjpeg-devel libmudflap libnscd libpng libpng-devel libstdc++ libstdc++-devel libtool libxcrypt libzio m4 mailx make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch pcre pcre-devel perl permissions popt post-build-checks procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim xorg-x11-devel xorg-x11-libs zlib zlib-devel


Name:           nagios
BuildRequires:  apache2-devel freetype2-devel gd-devel iputils libapr-util1-devel libjpeg-devel libpng-devel mailx pcre-devel xorg-x11-devel
Summary:        The Nagios Network Monitor
Version:        2.6
Release:        13.19
Url:            http://www.nagios.org/
License:        GPL v2 or later
Group:          System/Monitoring
PreReq:         %insserv_prereq %fillup_prereq sed grep coreutils /usr/sbin/useradd /usr/sbin/groupadd
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%define nsusr nagios
%define nsgrp nagios
%define cmdusr nobody
%define cmdgrp www
%define nslockfile_dir /var/run/nagios
%define nslockfile %{nslockfile_dir}/nagios.pid
%define apxs2 /usr/sbin/apxs2-prefork
%define apache2_sysconfdir %(%{apxs2} -q SYSCONFDIR)
Source0:        %{name}-%{version}.tar.bz2
Source1:        rcnagios
Source2:        nagios.quick-start.txt
Source3:        nagios-httpd.conf
Source6:        nagios.logrotate
Patch:          nagios.sehandlers.end_time.patch
Patch1:         nagios.avail.host_name.patch
Patch2:         nagios.sample-config.email-admin-localhost.patch
Patch3:         nagios.doc.faq-link.patch
Patch20:        nagios-2.6-CVE-2007-5624.diff
Patch21:        nagios-2.6-CVE-2008-1360.diff
Patch22:        nagios-2.6-CVE-2007-5803.diff
Patch23:        nagios-statuswml_c.patch

%description
The Nagios Network Monitor



Authors:
--------
    Ethan Galstad <nagios@nagios.org>

%debug_package
%package www
License:        GPL v2 or later
Group:          System/Monitoring
Summary:        Nagios Network Monitor
PreReq:         http_daemon
Requires:       nagios gd 

%description www
Nagios Network Monitor



Authors:
--------
    Ethan Galstad <nagios@nagios.org>

%prep
%setup -q
%patch -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23

%build
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" \
./configure \
	--with-cgiurl=/nagios/cgi-bin \
	--with-htmurl=/nagios \
	--with-lockfile=%{nslockfile} \
	--with-nagios-user=%{nsusr} \
	--with-nagios-grp=%{nsgrp} \
	--with-command-user=%{cmdusr} \
	--with-command-grp=%{cmdgrp} \
	--prefix=%{_prefix} \
	--exec-prefix=%{_prefix}/sbin \
	--bindir=%{_prefix}/sbin \
	--sbindir=%{_prefix}/lib/nagios/cgi \
	--libexecdir=%{_prefix}/lib/nagios/plugins \
	--datadir=%{_prefix}/share/nagios \
	--sysconfdir=/etc/nagios \
        --with-init-dir=/etc/init.d \
	--localstatedir=/var/lib/nagios \
	--with-gd-inc=/usr/include/gd \
	--enable-embedded-perl \
	--enable-event-broker \
	--with-perlcache 
make all %{?jobs:-j%jobs}
sed -i~ -e '
s@/var/lib/nagios/rw/@/var/spool/nagios/@
s@/var/lib/nagios/nagios.log@/var/log/nagios/nagios.log@
s@/var/lib/nagios/archives@/var/log/nagios/archives@
s@^nagios_user=daemon$@nagios_user=%{nsusr}@
s@^nagios_group=nagios$@nagios_group=%{nsgrp}@
' sample-config/nagios.cfg
diff -u sample-config/nagios.cfg~ sample-config/nagios.cfg || :
cd contrib
make %{?jobs:-j%jobs}
cd ..

%install
install -d -m 0775 ${RPM_BUILD_ROOT}/var/spool/nagios
install -d -m 0775 ${RPM_BUILD_ROOT}/var/log/nagios
install -d -m 0775 ${RPM_BUILD_ROOT}/var/log/nagios/archives
install -d -m 0755 ${RPM_BUILD_ROOT}%{_prefix}/include/nagios
install -d -m 0755 ${RPM_BUILD_ROOT}/etc/init.d
install -d -m 0755 ${RPM_BUILD_ROOT}/%{apache2_sysconfdir}/conf.d/
install -d -m 0755 ${RPM_BUILD_ROOT}/etc/logrotate.d/
install -d -m 0755 ${RPM_BUILD_ROOT}%{nslockfile_dir}
cp %{S:2} quick-start.txt
chmod 644 quick-start.txt
touch ${RPM_BUILD_ROOT}%{nslockfile}
make DESTDIR=$RPM_BUILD_ROOT INSTALL_OPTS="" COMMAND_OPTS="" INIT_OPTS= STRIP=: install
make DESTDIR=$RPM_BUILD_ROOT INSTALL_OPTS="" COMMAND_OPTS="" INIT_OPTS= CGICFGDIR=/etc/nagios install-config
for i in $RPM_BUILD_ROOT/etc/nagios/*-sample ; do
  mv $i ${i%%-sample}
done
# devel
install -m 0644 include/locations.h ${RPM_BUILD_ROOT}%{_prefix}/include/nagios
#
cd contrib
make DESTDIR=$RPM_BUILD_ROOT INSTALL=install CGIDIR=%{_prefix}/lib/nagios/cgi INSTALL_OPTS= install
cd ..
install -d -m 755 $RPM_BUILD_ROOT%{_prefix}/lib/nagios/plugins
# install SuSE specials 
cp %{SOURCE3} $RPM_BUILD_ROOT/%{apache2_sysconfdir}/conf.d/nagios.conf
sed "s@^NAGIOS_PID=.*@NAGIOS_PID=%{nslockfile}@" %{SOURCE1} > $RPM_BUILD_ROOT/etc/init.d/nagios
ln -sf ../../etc/init.d/nagios $RPM_BUILD_ROOT/usr/sbin/rcnagios
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT/etc/logrotate.d/nagios

%pre
/usr/sbin/groupadd -r nagios 2> /dev/null || :
/usr/sbin/useradd  -r -o -g nagios -s /bin/false -c "User for Nagios" -d /var/lib/nagios nagios 2> /dev/null || :

%post
%{fillup_and_insserv nagios}
# Update ?
if [ ${FIRST_ARG:-0} -gt 1 ]; then
 if [ -f /etc/nagios/nagios.cfg ]; then 
  if ! grep -q lock_file=%{nslockfile} /etc/nagios/nagios.cfg ; then
   echo "updating pid lock_file= to %{nslockfile} in /etc/nagios/nagios.cfg" 
   sed -i "s@^lock_file=.*@lock_file=%{nslockfile}@" /etc/nagios/nagios.cfg 
  fi
 fi
fi

%preun
%stop_on_removal nagios

%postun
if test -f %{nslockfile}
then
	chown -v %{nagios} %{nslockfile}
fi
%restart_on_update nagios
%{insserv_cleanup}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc quick-start.txt
%dir %{_prefix}/lib/nagios
%dir %{_prefix}/lib/nagios/plugins
%dir /etc/nagios
%dir %{_prefix}/include/nagios
%dir %attr(755,%{nsusr},%{nsgrp}) /var/lib/nagios
%dir %attr(755,%{nsusr},%{nsgrp}) /var/log/nagios
%dir %attr(755,%{nsusr},%{nsgrp}) /var/log/nagios/archives
%dir %attr(2775,%{nsusr},%{cmdgrp}) /var/spool/nagios
%dir %attr(755,%{nsusr},%{nsgrp}) %{nslockfile_dir}
%attr(0644,%{nsusr},%{nsgrp}) %verify(not md5 size mtime) %ghost %config(missingok,noreplace) /var/run/nagios/nagios.pid
%attr(0744,root,root) %config /etc/init.d/nagios
%{_prefix}/sbin/*
%{_prefix}/include/nagios/locations.h
%config(noreplace) /etc/nagios/[!r]*
%attr(640,root,%nsgrp) %config(noreplace) /etc/nagios/resource.cfg
%config /etc/logrotate.d/nagios
%doc Changelog LICENSE README* UPGRADING

%files www
%defattr(-,root,root)
%dir %{_prefix}/lib/nagios/cgi
%dir %{_prefix}/share/nagios
%{_prefix}/lib/nagios/cgi/*
%{_prefix}/share/nagios/*
%dir %{apache2_sysconfdir}/conf.d
%config(noreplace) %{apache2_sysconfdir}/conf.d/*

%changelog
* Wed Jul 01 2009 - cschneemann@suse.de
- fix nagios remote code exec via CGI, CVE-2009-2288 (bnc#517311)
* Wed Apr 09 2008 - lnussel@suse.de
- use better patches for CVE-2008-1360, CVE-2007-5803 and
  CVE-2007-5624 (bnc#339447, bnc#372037).
* Wed Mar 05 2008 - olh@suse.de
- extend last change to fix CVE-2007-5624 (bnc#339447)
* Tue Jan 08 2008 - olh@suse.de
- Bug fixes to prevent possible XSS attack in CGIs (339447)
  CVE-2007-5624
* Thu Feb 01 2007 - olh@suse.de
- add quick-start.txt (#237372)
* Thu Feb 01 2007 - olh@suse.de
- remove unneeded trailing slashes from Alias and Directory entries
  in nagios-http.conf
* Wed Jan 17 2007 - olh@suse.de
- fix more comparison with string literal in avail.c
* Thu Jan 11 2007 - olh@suse.de
- FATE #301512
* Thu Jan 11 2007 - olh@suse.de
- fix typo in html docu, perdata.html -> perfdata.html
* Thu Jan 11 2007 - olh@suse.de
- correct link to external FAQ website
* Thu Jan 11 2007 - olh@suse.de
- correct Alias in nagios-httpd.conf
* Wed Jan 10 2007 - olh@suse.de
- update the default example config to mail to nagios%%localhost
  instead to non-existant nagios-admin%%localhost
* Wed Jan 10 2007 - olh@suse.de
- fix comparison with string literal (#232415)
* Mon Jan 08 2007 - olh@suse.de
- move pid file to /var/run/nagios/ (#231169)
* Fri Dec 01 2006 - tsieden@suse.de
- update to version 2.6
  * fix for unscheduled triggered downtime entries
  * fix for embedded audio in tac and status CGIs
  * fixed bug in nagiostats utility when reporting host/service check latency
  * misc code cleanups for compiler warnings
  * fixed error when reading empty (zero byte) config files
  * default is now to check for orphaned service checks (Francois Caen)
  * fixed bug with non-standard CGI config file location in status data (Carson Gaspar)
  * fixed bugs and simplified examples in sample config files (Mark Young)
  * removed obsolete patches which are included in upstream now
- fixed "empty PID file error" in init script
* Thu Nov 16 2006 - tsieden@suse.de
- changed home dir to /var/lib/nagios (#221791)
* Tue Oct 17 2006 - olh@suse.de
- fix uninitialized variable in run_global_service_event_handler (212892)
* Mon Sep 18 2006 - olh@suse.de
- add a user/group nagios (#61908)
* Fri Sep 08 2006 - olh@suse.de
- update to version 2.5
  disable sapmon patch for the time being
* Wed May 24 2006 - schwab@suse.de
- Don't build as root.
- Don't strip binaries.
- Fix format string bug.
* Wed May 03 2006 - stark@suse.de
- fixed possible buffer overflow in CGI scripts (#140494)
  (CVE-2006-2162)
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 09 2006 - stark@suse.de
- fixed off-by-one overflow (#141124)
* Fri Nov 18 2005 - stark@suse.de
- update to stable version 1.3
* Thu Oct 06 2005 - stark@suse.de
- fixed autobuild warnings about printf format
* Sat May 14 2005 - stark@suse.de
- fixed compiler errors about usage of uninitialized vars
* Sun Apr 24 2005 - aj@suse.de
- Compile with GCC4.
* Mon Aug 30 2004 - ro@suse.de
- removed apache1 traces
* Mon May 03 2004 - stark@suse.de
- fix compiler-warnings
* Tue Feb 03 2004 - stark@suse.de
- update to nagios 1.2
* Thu Sep 18 2003 - stark@suse.de
- /usr/lib/nagios and /usr/lib/nagios/plugins are owned
  by root (#31100)
* Mon Sep 08 2003 - stark@suse.de
- add apache2 config-files, require http_daemon
  and need apache2-devel-packages for build (#30157)
* Wed Aug 27 2003 - ro@suse.de
- remove traceroute-lbl from neededforbuild
  traceroute from net-tools is used anyway
* Mon Aug 18 2003 - stark@suse.de
- added activation meta-data to sysconfig (#28830)
* Fri Aug 15 2003 - poeml@suse.de
- change cmdgrp from nogroup to www (the group apache now runs
  under) [#21782]
- implement try-restart correctly
* Thu Jul 31 2003 - stark@suse.de
- use stop/restart macros
* Tue Jul 29 2003 - aj@suse.de
- Fix chown invocation.
* Fri Jul 25 2003 - stark@suse.de
- added bugfixes
* Thu Jun 12 2003 - kukuk@suse.de
- Make sure plugin directory exist
* Thu Jun 12 2003 - kukuk@suse.de
- Add nagios libdir to filelist
* Wed Jun 04 2003 - stark@suse.de
- update to bugfix release 1.1
  * File descriptor leak in file-based performance routines
  * Timestamp fix for PostgreSQL 7.3
  * Minor bug fixes to cmd and history CGIs
  * Minor documentation fixes
* Mon Jan 13 2003 - stark@suse.de
- added sysconfig-metadata (#22607)
* Mon Dec 02 2002 - stark@suse.de
- adopted sapmoni.dif for gcc 3.3
* Mon Nov 25 2002 - stark@suse.de
- update to 1.0 final
  * Minor bug fixes in CGIs
  * Minor doc updates
  * Bug fix for flex host downtime
  * Embedded perl bug fixe for arguments with spaces
  * Host escalation logic fix
* Tue Oct 15 2002 - stark@suse.de
- running pre-flight configuration check always when
  starting nagios (#20916)
- added logrotate definitions for logfiles
- fixed embedded perl (#20916) (thanks to mls)
* Mon Sep 23 2002 - stark@suse.de
- update to 1.0b6
  * Added wildcards and multiple hosts/hostgroups to host dependency
  and service dependency definitions
  * Added wildcard support for members directive in hostgroup
  definitions
  * Minor bug fixes and cleanups in CGIs
  * Minor cleanups in the core
  * New version of snprintf() included that supports %%f
  * Notification interval for escalations now defaults to
  non-escalated value
* Fri Aug 23 2002 - stark@suse.de
- update to 1.0b5
  * Fixed memory leak related to processing of passive checks
  * Memory leak fixes in the CGIs
  * Minor interface changes to the status and TAC CGIs
  * Bug fix in the notification CGI
  * Added minimalistic sample object config file (minimal.cfg)
* Fri Aug 16 2002 - stark@suse.de
- added PreReq (Bug #17938 #17939)
* Mon Aug 12 2002 - stark@suse.de
- updated sapmoni patch to provide documentation
* Mon Aug 12 2002 - mls@suse.de
- made it work with threaded perl-5.8
* Thu Aug 08 2002 - stark@suse.de
- added patch to be able to use nagios-plugins-sap
* Sat Jul 27 2002 - adrian@suse.de
- fix neededforbuild
* Fri Jul 05 2002 - stark@suse.de
- update to 1.0b4
  * Address field in host definitions is now optional in
  template-based config format. Defaults to host name if not
  specified.
  * Fixed memory leak when processing passive checks
  * Added illegal_macro_output_chars variable to main config file
  to allow for stripping dangerous shell characters from plugin
  output
* Wed Jun 12 2002 - stark@suse.de
- removed -devel subpackage and moved the file to main-package
* Mon Jun 10 2002 - stark@suse.de
- update to 1.0b3
  * Bug fixes in template-based object code
  * Bug fix in tac CGI for counting host and service states
  properly
  * Default is now to check for external commands as often as
  possible
  * Ping syntax for WAP interface moved to CGI config file
  * Command file user/group defaults to Nagios user/group unless
  overridden with configure script options
  * Sample template-based object config file fixes
* Tue May 28 2002 - stark@suse.de
- update to 1.0b2
  * Fixed bug with escaping strings for DB support
  (MySQL & PostgreSQL)
  * Several bug fixes in template-based object code
  * Multiple hostgroups supported in host and service escalations
  * Wildcard support in service, service escalation, and host
  escalation definitions
* Thu May 23 2002 - stark@suse.de
- install config-file templates
* Wed May 22 2002 - stark@suse.de
- initial version of Nagios (the successor of NetSaint)
